Port equ 0fch
tempo equ 220

Pulse:
; in:
;   bc = cycle
    in a,(Port) 
    or 01h
    out (Port), a
    push bc
        do
            dec bc
            ld a,c
            or b
        while nz | wend
    pop bc
    in a,(Port)
    and not 01h
    out (Port), a
    push bc
        do
            dec bc
            ld a,c
            or b
        while nz | wend
    pop bc
ret 


Tone:
; in:
;   b = cycle
;   hl = length
    push de
        do
            call Pulse
            or a
            sbc hl,bc
        while nc | wend
    pop de
ret 




Sound_Get_:
    public Sound_Get_
    push af | push hl | push bc
        ld bc,200
        ld hl,1000
        call Tone
    pop bc | pop hl | pop af
ret 


Sound_Hit_:
    public Sound_Hit_
    push af | push bc
        ld bc, 300
        do
            Sound_Hit_.Loop:
            call Pulse
            dec bc
            ld a,b
            or a
            jr nz,Sound_Hit_.Loop
            ld a,c
            cp 150
        while nz | wend
    pop bc | pop af
ret 

Sound_Miss_:
    public Sound_Miss_
    push af | push bc
        ld bc, 150
        do
            Sound_Miss_.Loop:
            call Pulse
            inc bc
            ld a,b
            or a
            jr z,Sound_Miss_.Loop
            ld a,c
            cp low 300
        while nz | wend
    pop bc | pop af
ret 


Sound_Loose_:
    public Sound_Loose_
    push af | push hl | push bc
        ld l,10
        ld bc,500
        do
            call Pulse
            dec l
        while nz| wend
    pop bc | pop hl | pop af
ret 


cycles:
defw 294   ;C4
defw 277   ;C#4
defw 261   ;D4
defw 247   ;D#4
defw 233   ;E4
defw 220   ;F
defw 207   ;F#4
defw 196   ;G4
defw 185   ;G#4
defw 174   ;A4
defw 165   ;A#4
defw 155   ;B4
defw 147   ;C5

C4 equ 1
D4 equ 3
E4 equ 5
F4 equ 6
G4 equ 8
A4 equ 10
B4 equ 12
C5 equ 13


Melody: 
; in
;   hl: address
    push af
    push de
    push bc
        do
            ld c,(hl) | inc hl
            ld b,(hl) | inc hl
            ld a,c
            or a
        while nz
            push hl
                dec b
                ld l,b
                ld h,0
                add hl,hl
                ld de,cycles
                add hl,de
                ld c,(hl)
                inc hl
                ld b,(hl)
            pop hl
            push hl
                ld h,a
                ld l,0
                ld d,h
                ld e,l
                add hl,hl
                add hl,de
                add hl,hl
                add hl,hl
                call Tone
            pop hl
        wend
    pop bc
    pop de
    pop af
ret

start_notes: defb 3,C4, 3,G4, 3,E4, 3,G4, 12,C5, 0

Sound_Start_:
    public Sound_Start_
    push hl
        ld hl,start_notes
        call Melody
    pop hl
ret

clear_notes: defb 3,C4, 3,E4, 3,G4, 3,D4, 3,F4, 3,A4, 3,E4, 3,G4, 3,B4, 9,C5,0

Sound_Clear_:
    public Sound_Clear_
    push hl
        ld hl,clear_notes
        call Melody
    pop hl
ret

over_notes: defb 3,C5, 3,G4, 3,E4, 3,C5,  3,B4, 3,G4, 3,E4, 3,B4,  6,A4, 6,B4,  12,C5, 0

Sound_GameOver_:
    public Sound_GameOver_
    push hl
        ld hl,over_notes
        call Melody
    pop hl
ret
