#include "Sprite.h"
#include "Chars.h"
#include "VVram.h"
#include "Vram.h"

constexpr byte InvalidCode = 0xff;
Sprite[SpriteCount] Sprites;


void InitSprites()
{
    HideAllSprites();
}


void HideAllSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        p->code = InvalidCode;
    }
}


void ShowSprite(byte index, byte x, byte y, byte code)
{
    ptr<Sprite> p;
    p = Sprites + index;
    if (p->code != InvalidCode) {
        SetRowFlags(p->y, 3);
    }
    x = (x + 4) >> 3;
    y = (y + 4) >> 3;
    if (p->x != x || p->y != y || p->code != code) {
        p->x = x;
        p->y = y;
        p->code = code;
        SetRowFlags(p->y, 3);
    }
}


void HideSprite(byte index) 
{
    ptr<Sprite> p;
    p = Sprites + index;
    if (p->code != InvalidCode) {
        SetRowFlags(p->y, 3);
    }
    p->code = InvalidCode;
}

void DrawSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->code != InvalidCode) {
            ptr<byte> pVVram;
            byte y, c;
            y = p->y;
            pVVram = VVramPtr(p->x, y);
            c = p->code;
            pVVram[0] = c; 
            ++c; pVVram[1] = c;
            ++c; pVVram[VVramWidth] = c;
            ++c; pVVram[VVramWidth + 1] = c;
            SetRowFlags(p->y, 3);
        }
    }
}
