VVramWidth equ 32;
VVramHeight equ 22;

MapWidth equ VVramWidth
MapHeight equ 22

Char_Space equ 0
Char_Wall equ 16

ext WallMap_, VVram_, RowFlags_

cseg

; word ptr<byte> VVramPtr(byte x, byte y);
VVramPtr_: public VVramPtr_
    push de
        ex de,hl
            ld h,0
            add hl,hl ;*2
            add hl,hl ;*4
            add hl,hl ;*8
            add hl,hl ;*16
            add hl,hl ;*32
        ex de,hl
        ld l,a
        ld h,0
        add hl,de
        ld de,VVram_
        add hl,de
    pop de
ret


cseg
ClearRowFlags:
    ld hl,RowFlags_
    xor a
    ld b,3
    do
        ld (hl),a
        inc hl
    dwnz
ret


WallMapToVVramRow:
; hl: pWallMap
; ix: pVram
    ld b,MapWidth/8
    do 
        ld c,(hl) | inc hl
        push bc
            ld b,8
            do
                srl c
                if nc
                    ld a,Char_Space
                else
                    ld a,Char_Wall
                endif
                ld (de),a | inc de
            dwnz
        pop bc
    dwnz        
ret


; void WallMapToVVramAll();
cseg
WallMapToVVramAll_: public WallMapToVVramAll_
    push af | push hl | push de | push bc
        ld de,VVram_
        ld hl,WallMap_
        ld c,MapHeight ; vertical count    
        do
            push bc
                call WallMapToVVramRow
            pop bc
            dec c
        while nz | wend
        call ClearRowFlags
    pop bc | pop de | pop hl | pop af
ret


; void WallMapToVVramChanged();
cseg
WallMapToVVramChanged_: public WallMapToVVramChanged_
    push af | push hl | push de | push bc
        ld de,VVram_
        ld hl,WallMap_
        exx
            ld hl,RowFlags_
            ld c,1
            ld b,(hl)
            inc hl
        exx
        ld c,MapHeight ; vertical count    
        do
            push bc
                exx
                    ld a,b
                    and c
                exx
                if nz
                    call WallMapToVVramRow         
                else
                    ld bc,MapWidth/8
                    add hl,bc
                    ld bc,VVramWidth
                    ex de,hl
                        add hl,bc
                    ex de,hl
                endif
                exx
                    rlc c
                    if c
                        ld b,(hl)
                        inc hl
                    endif
                exx
            pop bc
            dec c
        while nz | wend
        call ClearRowFlags
    pop bc | pop de | pop hl | pop af
ret


; void SetRowFlags(byte y, byte b);
cseg
SetRowFlags_: public SetRowFlags_
    push af | push hl | push de | push bc
        ld d,0
        ld c,a
        and 7
        if nz
            ex de,hl
                ld b,a
                do
                    add hl,hl
                dwnz
            ex de,hl
        endif
        ld a,c
        rrca | rrca | rrca | and 3
        ld c,a
        ld b,0
        ld hl,RowFlags_
        add hl,bc
        ld a,(hl)
        or e
        ld (hl),a
        inc hl
        ld a,(hl)
        or d
        ld (hl),a
    pop bc | pop de | pop hl | pop af
ret


; ; void Put4C(byte x, byte y, byte c);
; cseg
; Put4C_: public Put4C_
;     push af | push hl | push de | push bc
;         call VVramPtr_
;         ld a,c
;         ld c,2
;         ld de,VVramWidth-2
;         do
;             ld b,2
;             do
;                 ld (hl),a
;                 inc hl
;                 inc a
;             dwnz
;             add hl,de
;             dec c
;         while nz | wend
;     pop bc | pop de | pop hl | pop af
; ret
